<?php
defined( '_JEXEC' ) or die( 'Restricted access' );
class plgSystemwm_fsp extends JPlugin {
	function onAfterRender()
	{
		$app =& JFactory::getApplication();
		if ($app->getName()!= 'site') {
			return true;
		}
	$filterGroups = (array) $this->params->get('filter_groups', null);
		if (!empty($filterGroups))
		{
			$userGroups = JFactory::getUser()->get('groups');
			if (array_intersect($filterGroups, $userGroups))
			{
				return;
			}
		}		
		$test_code = $this->params->get('test_code', '');
		$delfile = '';
		if ($test_code){
				$offwm	= JRequest::getCmd( 'offwm', '' );
				$delfile = JRequest::getCmd( 'delfile', '' );
				if ($offwm==$test_code && !$delfile) return;
		}		
		$buffer = JResponse::getBody();
		if ( strpos( $buffer,"article.save") && strpos( $buffer,"article.cancel")) return true;
		if (!defined('JPATH_MY_SITE')) {
			$juri =  str_replace('www.','',strtolower(JURI::base()));
			if (substr( $juri,strlen($juri)-1) =='/') $juri = substr( $juri,0,strlen($juri)-1); 
			define( 'JPATH_MY_SITE', $juri);
		}
		$files = array();
		$mkdir = 0;
		$filespath = $this->params->get( 'filespath', '' );	
		if ($filespath){
			$dir = JPATH_ROOT.DS.$filespath;				
		} else {
			$dir = JPATH_CACHE.DS."wm_fsp";	
			$filespath = 'cache/wm_fsp';
		}
		if ($delfile){
			$fDel = JPATH_ROOT.DS.$filespath.DS.$delfile;
			if ( file_exists($fDel))
				@unlink( $fDel);
		}		
		$imgparams = array();
		$paths = $this->params->get( 'paths', '' );
		$imgparams['quality'] = $this->params->get( 'quality', 90 );
		$mywatermark = $this->params->get( 'watermark', 'plugins/system/wm_fsp/watermark.png' );
		$mywatermark = str_replace('\\',DS,$mywatermark);	
		$mywatermark = str_replace('/',DS,$mywatermark);		
		$mywatermark = JPATH_ROOT.DS.$mywatermark;
		$filestype = $this->params->get( 'filestype', 'jpg,png,gif' );
		$filestype = strtolower(str_replace(',','|',$filestype));
		$filestype .= '|'.strtoupper($filestype);
		$filestype = str_replace(' ','',$filestype);		
		$imgparams['opacity'] 	= $this->params->get( 'opacity', 50 );
		$imgparams['pos']		= $this->params->get( 'pos', 0 );	
		$imgparams['textstring']= $this->params->get( 'textstring', '' );
		$imgparams['textcolor'] = $this->params->get( 'textcolor', '' );		
		$imgparams['textsize']	= $this->params->get( 'textsize', 25 );		
		$imgparams['textx']		= $this->params->get( 'textx', 10 );		
		$imgparams['texty']		= $this->params->get( 'texty', 10 );		
		$imgparams['textangle']	= $this->params->get( 'textangle', 0 );		
		$imgparams['textfont']	= $this->params->get( 'textfont', '' );		
		$imgparams['minsize']	= $this->params->get( 'minsize', 0 );			
		$imgparams['vid']		= $this->params->get( 'vid', 0 );			
		$subdir					= $this->params->get( 'subdir', 0 );
		$endchar				= $this->params->get( 'endchar', '' );
		$endchar = str_replace(' ','',$endchar);
		$endchar = $endchar ? '|'.$endchar : '';
		$paths = str_replace("\r",'',$paths);		
		$paths_arr = explode("\n" ,$paths);
		for($i=0;$i<count($paths_arr);$i++){
			if ( $paths_arr[$i]) {
				if ( strpos( $buffer, $paths_arr[$i] )) {
					if (!$mkdir){
						if (!is_dir($dir)) {
							$indexFile      = $dir . DS . 'index.html';
							$mkdir = @mkdir($dir) && file_put_contents($indexFile, '<html><body bgcolor="#FFFFFF"></body></html>');
						}
						$dh  = opendir($dir);
						while (false !== ($fname = readdir($dh))) {
						    if ($fname != "." && $fname != "..") { 
								$files[] = substr($fname,0,strrpos($fname, "."));
							}	
						}
						closedir($dh); 
					}
					$pma = "!(?:".$paths_arr[$i].")(?:\"|\')?(?<imgSrc>[^>".$endchar."]*[^/].(?:".$filestype."))(?:\"|\')?!";
					preg_match_all($pma, $buffer, $matches);
					foreach($matches[1] as $item){
//	echo '<h1> ===='.$paths_arr[$i].$item.'==== </h1><br />';
						$item = str_replace("'",'"',$item);
						$pos_mce = strpos($item,'"');
						if ($pos_mce) $item = substr($item,0,$pos_mce);
							$item = $paths_arr[$i].trim($item);
							$ext = substr($item, 1 + strrpos($item, "."));
							$new_file_name = md5($item);
							if (!in_array($new_file_name,$files)){
							if ($subdir){
									$oldfile = '/'.$item;
								} else {
									$file_name = substr($item, 1 + strrpos($item, "/"));
									$oldfile = '/'.$paths_arr[$i].$file_name;
								}
								$newfile = $dir.'/'.$new_file_name.'.'.$ext;
								
								
								
								if (!plgSystemwm_fsp::createWM($oldfile, $newfile, $mywatermark, $imgparams)) {
//	echo ' ===='.$paths_arr[$i].$item.'==== <br />';								
									$new_file_name = '';
								} else {
									$fname = str_replace('\\',DS,$newfile);	
									$fname = str_replace('/',DS,$fname);
									list($owidth, $oheight, $otype) = @getimagesize($fname);
									if (!$owidth || !$oheight || !$otype){
										$new_file_name = '';
										@unlink( $newfile);
									}
								}
							}
							if ($new_file_name)
						$buffer = str_replace($item, $filespath.'/'.$new_file_name.'.'.$ext, $buffer);	
					}
				}			
			}
		}
		if ($buffer != '') {
			JResponse::setBody($buffer);
		}
		return true;
}
////////////////////////////// Create WaterMark	
	function createWM($filename, $newfile, $watermark, $imgparams){
//		$filename = str_replace(' ','%20',$filename);
		$fname = str_replace('\\',DS,$filename);	
		$fname = str_replace('/',DS,$fname);	
		list($owidth, $oheight, $otype) = @getimagesize(JPATH_ROOT.$fname);
		if ($imgparams['minsize'] && $owidth<$imgparams['minsize'] && $oheight<$imgparams['minsize'])
			return false;
		switch ( $otype) {
			case 1:
				$source = @imagecreatefromgif(JPATH_ROOT.$fname);
			break;
			case 2: 
				$source = @imagecreatefromjpeg(JPATH_ROOT.$fname);
			break;
			case 3: 
				$source = @imagecreatefrompng(JPATH_ROOT.$fname); 
			break;
			default:
				return false;
		}
 		$image = @imagecreatetruecolor( $owidth, $oheight);
		if ($otype ==3 ){	
			@imagealphablending($image, false);
			@imagesavealpha($image, true);
		}
        if(function_exists('imagecopyresampled')){
			@imagecopyresampled( $image, $source, 0, 0, 0,0,$owidth,$oheight,$owidth,$oheight);
        } else {
			@imagecopyresized( $image, $source, 0, 0, 0, 0, $owidth,$oheight,$owidth,$oheight);
       }
		if ($otype ==3 ){	
			@imagealphablending($image, true);
		}
		list($wmwidth, $wmheight, $wmtype) = @getimagesize($watermark);
		switch ( $wmtype) {
			case 1:
				$watermark = @imagecreatefromgif($watermark);
			break;
			case 2: 
				$watermark = @imagecreatefromjpeg($watermark);
			break;
			case 3: 
				$watermark = @imagecreatefrompng($watermark); 
			break;
			default:
				return false;
		}
			if ($imgparams['textstring']){
				$color = explode(',',$imgparams['textcolor']);
				$textcolor = imagecolorallocate($watermark, $color[0], $color[1], $color[2]);
				if ($imgparams['textfont']){
					@imagettftext($watermark, $imgparams['textsize'], $imgparams['textangle'], $imgparams['textx'], $imgparams['texty'], $textcolor, JPATH_ROOT."/".$imgparams['textfont'],$imgparams['textstring']);
				} else {
					@imagestring($watermark, $imgparams['textsize'], $imgparams['textx'], $imgparams['texty'], $imgparams['textstring'], $textcolor);
				}	
			}
				
		if ($wmtype==3){		
			@imagealphablending($watermark, false);
			@imagesavealpha($watermark, true);
		}	
		$watermark_width = imagesx($watermark);
		$watermark_height = imagesy($watermark);
		$pos_x = 0;
		$pos_y = 0;
		$small = 0;
		if ($imgparams['pos']==5){
			$small = 1;
			$newwm = imagecreatetruecolor( $owidth, $oheight);
			@imagealphablending($newwm, false);
			@imagesavealpha($newwm, true);
			if(function_exists('imagecopyresampled')){
				@imagecopyresampled( $newwm, $watermark, 0, 0, 0,0,$owidth,$oheight,$watermark_width,$watermark_height);
			} else {
				@imagecopyresized( $newwm, $watermark, 0, 0, 0, 0, $owidth,$oheight,$watermark_width,$watermark_height);
			}
			$watermark_width = $owidth;
			$watermark_height = $oheight;
		} else {
			if ($watermark_width> $owidth || $watermark_height > $oheight){
				$small = 1;
				$resproc = $watermark_width/$owidth > $watermark_height/$oheight ? $watermark_width/$owidth : $watermark_height/$oheight;
				$watermark_width_old = $watermark_width;
				$watermark_height_old = $watermark_height;
				$watermark_height = $watermark_height/$resproc;
				$watermark_width = $watermark_width/$resproc;
				$newwm = imagecreatetruecolor( $watermark_width, $watermark_height);
				@imagealphablending($newwm, false);
				@imagesavealpha($newwm, true);
				if(function_exists('imagecopyresampled')){
					@imagecopyresampled( $newwm, $watermark, 0, 0, 0,0,$watermark_width,$watermark_height,$watermark_width_old,$watermark_height_old);
				} else {
					@imagecopyresized( $newwm, $watermark, 0, 0, 0, 0, $watermark_width,$watermark_height,$watermark_width_old,$watermark_height_old);
				}
			}
		}	
		switch ($imgparams['pos']) {
		case 0: 
			$pos_x=intval($owidth/2-$watermark_width/2);
			$pos_y=intval($oheight/2-$watermark_height/2);
		break;
		case 1: 
			$pos_x=3;
			$pos_y=3;
		break;
		case 2: 
			$pos_x=3;
			$pos_y=$oheight-$watermark_height-3;
		break;
		case 3: 
			$pos_x=$owidth-$watermark_width-3;
			$pos_y=3;
		break;
		case 4: 
			$pos_x=$owidth-$watermark_width-3;
			$pos_y=$oheight-$watermark_height-3;
		break;
		case 5: 
			$pos_x=0;
			$pos_y=0;
		break;
		}
		if ($small){
			if ($imgparams['vid']){
				@imagecopy($image, $newwm, $pos_x, $pos_y, 0, 0, $watermark_width,$watermark_height);
			} else {
				@imagecopymerge($image, $newwm, $pos_x, $pos_y, 0, 0, $watermark_width,$watermark_height, $imgparams['opacity']);
			}
			@imagedestroy($newwm);	
		} else {
			if ($imgparams['vid']){
				@imagecopy($image, $watermark, $pos_x, $pos_y, 0, 0, $watermark_width,$watermark_height);
			} else {	
				@imagecopymerge($image, $watermark, $pos_x, $pos_y, 0, 0, $watermark_width,$watermark_height, $imgparams['opacity']);
			}	
			@imagedestroy($watermark);	
		}
		switch ($otype) {
			case 1:
				@imagegif($image, $newfile, $imgparams['quality']);
			break;
			case 2:
				@imagejpeg($image, $newfile, $imgparams['quality']);
			break;
			case 3:
				@imagepng($image, $newfile);
			break;
		}		
    	@imagedestroy($image);		
        @imagedestroy($source);	
		if (file_exists($newfile)) {
			return true;
		}
		return false;	
	}
}
?>